using System
using Fx7
using Nemerle.Imperative

[Record] \
class CSV_Rabit : Rabit [CSV_Rabit]
  // the last position in each line is the expected result
  internal static mutable data : array [array [double]]
  internal static mutable names : array [string * int]
  static rand : Random = Random ()
  static max_mutate = 0.4
  static sign_mutate = 0.01

  coeff : array [double]
  
  public override CrossOver (other : CSV_Rabit) : CSV_Rabit
    def nc = array (coeff.Length)
    foreach (i in [0 .. nc.Length - 1])
      nc [i] = if (rand.Next (2) == 0) coeff [i] else other.coeff [i]
    CSV_Rabit (nc)

  public override MutateImpl () : void
    //foreach (i in [0 .. coeff.Length - 1])
    repeat (2)
      def i = rand.Next (coeff.Length)
      def v = max_mutate * coeff [i] 
      coeff [i] += rand.NextDouble () * 2 * v - v
      when (rand.NextDouble () < sign_mutate)
        coeff [i] = - coeff [i]

  public override JudgeImpl () : double
    mutable sum = 0.0
    foreach (row in data)
      mutable val = 0.0
      foreach (i in [0 .. coeff.Length - 1])
        val += coeff [i] * row [i]
      def trueval = row [coeff.Length]
      def diff = Math.Abs (val - trueval)
      sum += diff //(diff / trueval) * 10 + diff
    -(sum)

  public override ToString () : string
    mutable res = ""
    foreach (i in [0 .. coeff.Length - 1])
      res += $ "((\"$(names [i][0])\", $(names [i][1])), $(coeff [i])), "
    res


def lines = CSV.ReadFile ("log.csv")
def expected = ("user/sys time")
//def expected = "Time"
def factors = [
#if false
  ("num_main_iters", 0.0022), 
//  ("num_quant_loops", 0.003),
  ("num_quant_iters", 0.00035),
  ("instance_count", 0.00040),
  ("num_inst_rounds", 0.00044),
//  ("max_inst_rounds", 0.001),
  ("total_monome_size", 0.0000709),
  ("DPLL_saved_monome_size", -0.0000745),
  ("one", 0.708)
  ]
#endif
//("num_main_iters", 0.00537717596365364), ("num_quant_iters", -0.000149608383215986), ("instance_count", 0.000423278720991162), ("num_inst_rounds", -0.00040519286523859), ("total_monome_size", 8.0498205709907E-05), ("DPLL_saved_monome_size", -8.82012777489352E-05), ("one", 0.550475511028534)

// ("num_main_iters", 0.00721388376866574), ("instance_count", 0.000427091839562989), ("total_monome_size", 8.07175014917716E-05), ("DPLL_saved_monome_size", -8.82012777489352E-05), ("one", 0.475786212301735)
//("num_main_iters", 0.00659396842624661), ("instance_count", 0.000378238274392087), ("total_monome_size", 8.10738159525381E-05), ("DPLL_saved_monome_size", -8.81792331841566E-05), ("one", 0.535062070670228)

//("num_main_iters", 0.0089), ("instance_count", 0.00038), ("total_monome_size", 0.0001), ("DPLL_saved_monome_size", -0.0001), ("one", 0.4)
//("instance_count",0.0004), ("num_asserts",0.0001), ("num_clauses",0.0001), ("num_matchings",0.00001), ("one", 0.4)
//("instance_count", -1.95253009152374E-05), ("num_asserts", 0.000162433484714799), ("num_clauses", 0.000115749027081203), ("num_matchings", 9.52124239517016E-05), ("one", 0.212207147429921)
//("num_asserts", 0.000162433484714799), ("num_clauses", 0.000129620101598768), ("num_matchings", 0.000131125408405626), ("one", 0.118479587134284)

//(("num_asserts", 1), 0.000163189163694271), (("num_clauses", 1), 2.88844056879631E-05), (("num_matchings", 1), -0.000347986631302431), (("num_asserts", 2), -7.22355059384738E-10), (("num_clauses", 2), 6.51351664877632E-10), (("num_matchings", 2), 4.90370118566608E-08), (("one", 1), 2.33213086271673)
//(("num_asserts", 1), 0.000161314246614552), (("num_clauses", 1), 3.04658969165212E-05), (("num_matchings", 1), -0.000361870718617301), (("num_asserts", 2), -7.22355059384738E-10), (("num_clauses", 2), 6.51351664877632E-10), (("num_matchings", 2), 4.93255407023346E-08), (("one", 1), 2.39573143569683)

//0.8
//(("num_asserts", 1), 0.000161371456841661), (("num_clauses", 1), 3.04658969165212E-05), (("num_matchings", 1), -0.000363529379385738), (("num_asserts", 2), -7.22355059384738E-10), (("num_clauses", 2), 6.51351664877632E-10), (("num_matchings", 2), 4.93559857938289E-08), (("one", 1), 2.39905363399264)

//302
//  (("num_asserts", 1), 0.000145921288255455), (("num_clauses", 1), 3.94585770840933E-05), (("num_matchings", 1), -0.000773117930447053), (("num_asserts", 2), -1.23368042757203E-10), (("num_clauses", 2), 3.35085645728657E-10), (("num_matchings", 2), 6.607602232976E-08), (("one", 1), 4.23610728556244)

//300.6
(("num_asserts", 1), 0.000139969988185198), (("num_clauses", 1), 4.65006829002747E-05), (("num_matchings", 1), -0.00079894625041762), (("num_asserts", 2), -9.3366304251058E-11), (("num_clauses", 2), 3.10424425731029E-10), (("num_matchings", 2), 6.73898783232225E-08), (("one", 1), 4.2429615168996)

//0.97
// (("num_asserts", 1), 0.000107801644420169), (("num_clauses", 1), 7.3223608349805E-05), (("num_clauses", 2), 2.40061394181056E-10), (("num_matchings", 2), 2.79894021948736E-08), (("one", 1), 1.06324731445119)

//(("num_asserts", 1), 0.000108), (("num_clauses", 1), 7.32E-05), (("num_clauses", 2), 2.40E-10), (("num_matchings", 2), 2.80E-08), (("one", 1), 1.06)

//1.2
//(("num_asserts", 1), 0.000123099902837776), (("num_clauses", 1), 7.96542086320105E-05), (("num_matchings", 1), 0.000217588314139872), (("num_clauses", 2), 2.05786977245903E-10), (("one", 1), 0.470344163541103)

//(("num_asserts", 1), 0.000163189163694271), (("num_clauses", 1), 2.42070207458797E-05), (("num_matchings", 1), -0.000210684749584746), (("num_asserts", 2), -7.00272685397688E-10), (("num_clauses", 2), 6.6311876588885E-10), (("num_matchings", 2), 4.08675113444977E-08), (("one", 1), 2.00301367077488)
//("num_main_iters", 0.00700498205082933), ("num_quant_iters", -0.000560689566239577), ("instance_count", 0.000434316768212923), ("num_inst_rounds", -0.000538734714493756), ("total_monome_size", 8.05879995688291E-05), ("DPLL_saved_monome_size", -8.80946963943766E-05), ("one", 0.484671874831591)

//("num_quant_iters", 0.0041), ("instance_count", 0.00067), ("one", 0.278263044431125)
//("num_main_iters", 0.00537717596365364), ("num_quant_iters", 0.005608383215986), ("instance_count", 0.000423278720991162), ("one", 0.550475511028534)
]

def find (s)
  mutable i = 0
  foreach (e in "one" :: lines.Head)
    when (e == s)
      return (i)
    i++
  assert (false)

def positions = ($[ find (p) | ((p, _), _) in factors ] + [find (expected)]).ToArray ()
def coeffs = ($[c | ((_, c), _) in factors] + [1]).ToArray ()

def convert (line)
  def line = ("1" :: line).ToArray ()
  def res = array (positions.Length)
  foreach (i in [0 .. positions.Length - 1])
    res [i] = Math.Pow (double.Parse (line [positions [i]]), coeffs [i])
  res

CSV_Rabit.data = lines.Tail.Map (convert).ToArray ()
CSV_Rabit.names = $[x | (x, _) in factors].ToArray ()
def first_rabit = CSV_Rabit ($[ c | (_, c) in factors ].ToArray ())

Console.WriteLine ($"start: $(first_rabit.Score)")

def pop = Population ()
pop.Go ([first_rabit])
